--  button.e
--  jbabor@paradise.net.nz
--  00-11-22
--  widgets version 2.50

include panel.e

integer m1,m2

global function button(sequence label,integer x,integer y,integer w,integer h)
    integer k,wi,w1,w2

    wid = append(wid, {{"box","event","kbd","key","rat","show"},
        {{x,y,w,h},lbp+kbd_event,{},{},{m2},m1}})
    wi = length(wid)
    k = find('~', label)
    if k then bind(wi, "key", {label[k+1]}) end if

    w1 = panel(7, edge[1],x,y,w,h)
    affix(wi, "panel", w1)

    w2 = text(x + floor((w+1)/2), y + floor((h+1)/2), label)
    bind(w2, "just", CENTRE+BOXED)
    affix(wi, "label", w2)

    return wi
end function -- button

global procedure show_button(integer wi)
    show_panel(part(wi, "panel"))
    show_text(part(wi, "label"))
end procedure -- show_button
m1 = routine_id("show_button")

procedure on_rat_button()
    sequence s
    integer w1,w2,x,y

    w1 = part(self, "panel")
    bind(w1, "edge", edge[2])
    show_panel(w1)

    w2 = part(self, "label")
    retext(w2)
    x = item(w2, "x")
    y = item(w2, "y")
    s = item(w2, "string")
    setxy(x+1,y+1)
    hide_rat()
    write(s)
    show_rat()

    wait_while(lbp)

    bind(w1, "edge", edge[1])
    show_panel(w1)
    setxy(x,y)
    hide_rat()
    write(s)
    show_rat()
end procedure -- on_rat_button
m2 = routine_id("on_rat_button")
