--  panel.e
--  jbabor@paradise.net.nz
--  00-11-22
--  widgets version 2.50

include widgets.e

global constant edge = {
    {{11},{3}},         -- popped
    {{3},{11}}}         -- pushed

integer m

global function panel(  -- create instance of panel
    object color,       -- plain color, or 2d pattern
    object e,           -- if atom(e) then it is one line edge, and
                        -- line color = e, else e is a sequence of
                        -- the form {{i1,i2,...},{j1,j2...}}, where
                        -- i1, i2,... and j1, j2,...  are top left and
                        -- bottom right successive edge line colors
                        -- respectively, always going from outside in
    integer x,          -- left edge
    integer y,          -- top edge
    integer w,          -- width
    integer h           -- height
    )
    wid = append(wid, {{"box","color","edge","show"},{{x,y,w,h},color,e,m}})
    return length(wid)
end function -- panel

global procedure show_panel(integer wi)
    object c,e,h,p,w,x,y

    c = item(wi, "color")
    e = item(wi, "edge")
    p = item(wi, "box")
    x = p[1]
    y = p[2]
    w = p[3]
    h = p[4]
    hide_rat()
    bar(c,x,y,w,h)
    frame(e,x,y,w,h)
    show_rat()
end procedure
m = routine_id("show_panel")
