--  pbutton.e
--  jbabor@paradise.net.nz
--  00-11-22
--  widgets version 2.50

include panel.e
include pic.e

integer m1,m2

global function pbutton(
    integer x,          -- left edge
    integer y,          -- top edge
    integer w,          -- width
    integer h,          -- height
    sequence bmp,       -- bitmap
    integer xo,         -- x offset
    integer yo,         -- y offset
    integer kind        -- display kind: xor = -2, put = -1, merge >= 0
                        -- for merge, it is the transparent color
    )
    integer wi,w1,w2

    wid = append(wid, {{"box","event","kbd","key","rat","show"},
        {{x,y,w,h},lbp+kbd_event,{},{},{m2},m1}})
    wi = length(wid)

    w1 = panel(7, edge[1], x, y, w, h)
    affix(wi, "panel", w1)

    w2 = pic(x+xo,y+yo,bmp,kind)
    affix(wi, "pic", w2)

    return wi
end function -- pbutton

global procedure show_pbutton(integer wi)
    show_panel(part(wi, "panel"))
    show_pic(part(wi, "pic"))
end procedure -- show_pbutton
m1 = routine_id("show_pbutton")

procedure on_rat_pbutton()
    integer w1,w2,x,y

    w1 = part(self, "panel")
    w2 = part(self, "pic")
    bind(w1, "edge", edge[2])
    x = item(w2, "x")
    y = item(w2, "y")
    bind(w2, "x", x+1)
    bind(w2, "y", y+1)
    show_panel(w1)
    show_pic(w2)
    wait_while(lbp)
    bind(w1, "edge", edge[1])
    bind(w2, "x", x)
    bind(w2, "y", y)
    show_panel(w1)
    show_pic(w2)
end procedure -- on_rat_pbutton
m2 = routine_id("on_rat_pbutton")
