--  pic.e
--  jbabor@paradise.net.nz
--  00-11-22
--  widgets version 2.50

include widgets.e

integer m

global function pic(    -- create instance of picture
    integer x,          -- left edge
    integer y,          -- top edge
    sequence image,     -- bimap sequence
    integer kind        -- display kind: xor = -2, put = -1, merge >= 0
                        -- for merge, it is the transparent color
    )
    wid = append(wid, {{"x", "y", "image", "kind", "show"},
        {x, y, image, kind, m}})
    return length(wid)
end function -- pic

global procedure show_pic(integer wi)
    sequence  image
    integer x, y, kind

    x = item(wi, "x")
    y = item(wi, "y")
    image = item(wi, "image")
    kind = item(wi, "kind")
    hide_rat()
    if kind = -2 then
        xor_image(x,y,image)
    elsif kind=-1 then
        put_image(x,y,image)
    else
        merge_image(x,y,image,kind)
    end if
    show_rat()
end procedure -- show_pic
m = routine_id("show_pic")
